#include "basic_var.h"
#include "syscall.h"

#define DIGIT(i, str) ((i)&1 ? (str)[(i)>>1]&0xF : (str)[(i)>>1]>>4)
#define SET_DIGIT(i, str, n) ((str)[(i)>>1] |= ((i)&1 ?  (n)&0xF : ((n)&0xF)<<4))
#define SIGN(digit) ((digit)&4 ? -1 : 1)
#define IS_COMPLEX(str) (*(str)&0x80)

/* read functions */

int var_toint(char var)
{
	unsigned int n=0;
	unsigned char str[24], exponent, i;
	char sign;
	Alpha_GetData(var, str);
	sign = SIGN(DIGIT(0, str));
	exponent = DIGIT(1, str)*10 + DIGIT(2, str) + 1;
	if(exponent == 100) exponent=0;
	for(i=3 ; i<exponent+3 ; i++) n = n*10 + DIGIT(i, str);
	return sign * n;
}

double var_todouble(char var)
{
	double n=0;
	unsigned char str[24], exponent, i;
	char sign;
	Alpha_GetData(var, str);
	sign = SIGN(DIGIT(0, str));
	exponent = DIGIT(1, str)*10 + DIGIT(2, str) + 1;
	if(exponent == 100) exponent=0;
	for(i=3 ; i<18 ; i++) n = n*10 + DIGIT(i, str);
	for(i=0 ; i<15-exponent ; i++) n /= 10;
	return sign * n;
}

int var_imaginarypart_toint(char var)
{
	unsigned int n=0;
	unsigned char str[24], exponent, i;
	char sign;
	Alpha_GetData(var, str);
	if(!IS_COMPLEX(str)) return 0;
	sign = SIGN(DIGIT(24, str));
	exponent = DIGIT(25, str)*10 + DIGIT(26, str) + 1;
	if(exponent == 100) exponent=0;
	for(i=27 ; i<exponent+27 ; i++) n = n*10 + DIGIT(i, str);
	return sign * n;
}

double var_imaginarypart_todouble(char var)
{
	double n=0;
	unsigned char str[24], exponent, i;
	char sign;
	Alpha_GetData(var, str);
	if(!IS_COMPLEX(str)) return 0;
	sign = SIGN(DIGIT(24, str));
	exponent = DIGIT(25, str)*10 + DIGIT(26, str) + 1;
	if(exponent == 100) exponent=0;
	for(i=27 ; i<42 ; i++) n = n*10 + DIGIT(i, str);
	for(i=0 ; i<15-exponent ; i++) n /= 10;
	return sign * n;
}

/* write functions */

int var_reset(char var)
{
	char str[24] = {0};
	Alpha_SetData(var, str);
}

void var_setvarint(char var, int n)
{
	unsigned char str[24] = {0};
	int i, j;
	if(n) {
		if(n<0) {
			str[0] = 96;
			n = -n;
		} else str[0] = 16;
		for(i=n, j=0 ; i ; i/=10) j++;
		SET_DIGIT(2, str, j-1);
		for(; j ; j--, n/=10) SET_DIGIT(j+2, str, n%10);
	}
	Alpha_SetData(var, str);
}

